﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;
using System.Windows.Forms;

/*
 * By Gregor Spowart 
 * Mass Media Design 2008
 * http://www.massmediadesign.co.uk
 * gregor.spowart@massmediadesign.co.uk
 * Uses RSS Generator from http://www.primaryobjects.com/CMS/Article67.aspx
 * Use at your own risk- I'm liable for nothing!  :-)
 */ 

namespace ExportSubtext
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            FileStream MyFileStream = null;
            StreamWriter MyWriter = null;

            saveFileDialog1.Filter = "XML Files (*.xml)|*.xml";
            DialogResult result = saveFileDialog1.ShowDialog();

            try
            {
                MyFileStream = new FileStream(saveFileDialog1.FileName, FileMode.Create, FileAccess.Write);
                WriteOutput("Writing output");
                MyWriter = new StreamWriter(MyFileStream);

                // Get data from database
                string sqlGetBlogInfo = "SELECT Title, SubTitle, Host, Author FROM dbo.subtext_Config";
                string sqlGetEntries = "SELECT Title, DateAdded, Text, EntryName FROM dbo.subtext_Content";
                SqlConnection con = new SqlConnection(txtConnectionString.Text);
                SqlCommand com = new SqlCommand(sqlGetBlogInfo, con);
                com.CommandType = CommandType.Text;
                con.Open();
                SqlDataReader reader = com.ExecuteReader();
                while (reader.Read())
                {
                    // Write header of RSS file.
                    MyWriter.WriteLine("<?xml version=\"1.0\"?>");
                    MyWriter.WriteLine("<rss version=\"0.92\" xml:base=\"http://www.primaryobjects.com\">");
                    MyWriter.WriteLine("<channel>");
                    MyWriter.WriteLine("<title>" + reader["Title"].ToString() + "</title>");
                    MyWriter.WriteLine("<link>" + reader["Host"].ToString() + "</link>");
                    MyWriter.WriteLine("<description>" + reader["SubTitle"].ToString() + "</description>");
                    MyWriter.WriteLine("<language>en-us</language>");
                    // Done adding header of RSS file.

                }
                reader.Close();

                com.CommandText = sqlGetEntries;
                reader = com.ExecuteReader();
                DateTime publishedDate;
                // Begin adding items (article content).
                while (reader.Read())
                {
                    MyWriter.WriteLine("<item>");
                    MyWriter.WriteLine("<title>" + reader["Title"].ToString() + "</title>");
                    MyWriter.WriteLine("<link>" + reader["EntryName"].ToString() + "</link>");
                    MyWriter.WriteLine("<description><![CDATA[" + HttpUtility.HtmlDecode(reader["Text"].ToString()) + "]]></description>");
                    publishedDate = DateTime.Parse(reader["DateAdded"].ToString());
                    MyWriter.WriteLine("<pubDate>" + publishedDate.ToString("r") + "</pubDate>");
                    MyWriter.WriteLine("</item>");
                }
                
                // Write footer of RSS feed.
                MyWriter.WriteLine("</channel>");
                MyWriter.WriteLine("</rss>");

                WriteOutput("Blog exported");

            }
            catch (Exception excep)
            {
                WriteOutput("Exception : " + excep.Message);
            }
            finally
            {
                if (MyWriter != null)
                {
                    MyWriter.Close();
                }
                if (MyFileStream != null)
                {
                    MyFileStream.Close();
                }
            }
        }

        private void WriteOutput(string text)
        {
            txtOutput.Text += text + "\r\n";
        }


        private void btnQuit_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
